<!doctype html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <title>single page react boilerplate</title>
    <meta name="description" content="The HTML5 Herald" />
    <meta name="author" content="kokaneka" />
  </head>

  <body>
    <div id="place-app"></div>
    <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <script src="https://unpkg.com/react@16/umd/react.development.js"></script>
    <script src="https://unpkg.com/react-dom@16/umd/react-dom.development.js"></script>
    <script src="https://cdn.tailwindcss.com"></script>
    <script src="../../dist/browser//index.umd.js"></script>
    <script src="forest-web.js"></script>
    <script type="text/babel">
      const { useState, useEffect } = React;

      var App = (props) => {
        const [snapshots, setSnapshots] = useState([]);
        const [selectedIndex, setSelectedIndex] = useState(-1);

        const [recorder, setRecorder] = useState();
        const [machine, setMachine] = useState();
        const [app, setApp] = useState();
        const [changed, setChanged] = useState(0);

        const [sdkToken, setToken] = useState('');
        const [project_id, setProjectId] = useState('');

        useEffect(() => {
          async function run() {
            if (!sdkToken || !project_id) {
              return;
            }

            const recorder = new mintblue.MemoryRecorder();

            const machine = new mintblue.Machine(
              Forest,
              await mintblue.MintblueReader.create(sdkToken, project_id),
              await mintblue.MintblueWriter.create(sdkToken, project_id),
              recorder,
            );

            const app = machine.getInstance();

            setRecorder(recorder);
            setApp(app);
            setMachine(machine);

            machine.start();
            // Assuming `recorder` is globally available or imported here

            machine.on('snapshotRecorded', async () => {
              setSnapshots((await recorder.getSnapshots()) || []);
              setChanged((value) => value + 1);
              setSelectedIndex((await recorder.getSnapshots().length) - 1 || 0);
            });

            window.app = app;
            window.machine = machine;
            window.recorder = recorder;
          }

          run();
        }, [sdkToken, project_id]);

        if (!sdkToken || !project_id) {
          return (
            <div>
              <label>
                SDK Token:
                <input type="text" value={sdkToken} onChange={(event) => setToken(event.target.value)} />
              </label>
              <br />
              <label>
                Project ID:
                <input type="text" value={project_id} onChange={(event) => setProjectId(event.target.value)} />
              </label>
            </div>
          );
        }

        return (
          <div className="flex flex-col h-screen">
            <div className="flex flex-grow overflow-y-auto">
              <div className="flex-1 bg-gray-100 overflow-y-auto">
                <h1 className="text-xl p-4 border-b">Actions Recorded</h1>
                <ul>
                  {snapshots.map((snapshot, index) => (
                    <li
                      key={index}
                      className={`px-4 p-2 hover:bg-gray-200 cursor-pointer ${
                        selectedIndex === index ? 'bg-gray-200' : ''
                      }`}
                      onClick={() => {
                        setSelectedIndex(index);
                      }}
                    >
                      {snapshot.action ? (
                        <p>
                          {`${snapshot.action.f}(${snapshot.action.args.map((x) => JSON.stringify(x)).join(', ')})`}
                          <br />
                          <span className="text-cyan-500 text-xs">
                            <a
                              href={`https://www.whatsonchain.com/tx/${snapshot.ctx.reader.tx.txid}`}
                              target="_blank"
                              rel="noopener noreferrer" // added for security reasons
                            >
                              {`${snapshot.ctx.reader.tx.txid}`}
                            </a>
                          </span>
                        </p>
                      ) : (
                        <p>initial state</p>
                      )}
                    </li>
                  ))}
                </ul>
              </div>
              <div className="flex-1 p-4 bg-white">
                <h1 className="text-xl mb-4">State at Selected Time</h1>
                {snapshots[selectedIndex] ? (
                  <pre className="bg-gray-100 p-4 rounded">
                    <code>{JSON.stringify(snapshots[selectedIndex].state, null, 2)}</code>{' '}
                    {/* Assuming you have a state property */}
                  </pre>
                ) : (
                  <p>Select an action from the left to view its associated state.</p>
                )}
              </div>
            </div>
            {recorder && (
              <div className="bg-gray-900 p-4">
                <input
                  type="range"
                  min="0"
                  max={snapshots.length - 1}
                  value={selectedIndex}
                  onChange={(e) => setSelectedIndex(Number(e.target.value))}
                  className="w-full h-8 cursor-pointer"
                />
              </div>
            )}
          </div>
        );
      };
      ReactDOM.render(<App />, document.getElementById('place-app'));
    </script>
  </body>
</html>
